//+------------------------------------------------------------------+
//|                                                   Japan.mq4 |
//|                                                     Yuriy Tokman |
//|                                            yuriytokman@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Yuriy Tokman"
#property link      "yuriytokman@gmail.com"

#property indicator_chart_window
#property indicator_buffers 1
//---- input parameters
extern int    barsToProcess    = 1000;
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsNotify     = true;
extern bool   alertsEmail      = true;
extern string soundFile        = "alert2.wav"; 

double trend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  IndicatorBuffers(1);
  SetIndexBuffer(0,trend);
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
int i;
  
  
  
  for (i=0;i<Bars;i++)
    {
    ObjectDelete("   "+DoubleToStr(i,0));
    ObjectDelete("  "+DoubleToStr(i,0));
    ObjectDelete("  "+DoubleToStr(i,0));
    ObjectDelete("    "+DoubleToStr(i,0));
    ObjectDelete("   "+DoubleToStr(i,0));
    ObjectDelete(" "+DoubleToStr(i,0));
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted(),
//----
   limit,
   i=0; 
   if(counted_bars>0)
      counted_bars--;
   
   limit=Bars-counted_bars;
   
   if(limit>barsToProcess)
      limit=barsToProcess;

   while (i<limit)
   {           
                                 //  
      double k = (High[i]-Low[i])/3;
      trend[i] = trend[i+1];
      if ((Open[i]>(Low[i]+2*k))&&(Close[i]>(Low[i]+2*k)))
       {
        ObjectCreate("   "+DoubleToStr(i,0),OBJ_ARROW,0,Time[i],High[i]+10*Point);
        ObjectSet("   "+DoubleToStr(i,0),OBJPROP_ARROWCODE,108);
        ObjectSet("   "+DoubleToStr(i,0),OBJPROP_COLOR,DimGray);
       }            
                                // 
      if((Open[i+1]>Close[i+1])&&(Close[i+1]>Open[i])&&(Close[i]>Open[i+1]))
       {
        trend[i] = 1;
        ObjectCreate("  "+DoubleToStr(i,0),OBJ_ARROW,0,Time[i],Low[i]-15*Point);
        ObjectSet("  "+DoubleToStr(i,0),OBJPROP_ARROWCODE,110);
       }            
                               // 
       if((Close[i+1]>Open[i+1])&&(Open[i]>Close[i+1])&&(Open[i+1]>Close[i]))
       {
        trend[i] = -1;
        ObjectCreate("  "+DoubleToStr(i,0),OBJ_ARROW,0,Time[i],High[i]+15*Point);
        ObjectSet("  "+DoubleToStr(i,0),OBJPROP_ARROWCODE,110);
        ObjectSet("  "+DoubleToStr(i,0),OBJPROP_COLOR,Lime);
       }
                               //   
       if((Open[i+1]<Close[i+1])&&(Open[i]>High[i+1])&&(Close[i]<(Open[i+1]+(Close[i+1]-Open[i+1])/2)))
       {
        ObjectCreate("    "+DoubleToStr(i,0),OBJ_ARROW,0,Time[i],High[i]+25*Point);
        ObjectSet("    "+DoubleToStr(i,0),OBJPROP_ARROWCODE,116);
        ObjectSet("    "+DoubleToStr(i,0),OBJPROP_COLOR,Lime);
       }
                               //  
       if((Open[i+1]>Close[i+1])&&(Low[i+1]>Open[i])&&(Close[i]>(Close[i+1]+(Open[i+1]-Close[i+1])/2)))
       {
        ObjectCreate("   "+DoubleToStr(i,0),OBJ_ARROW,0,Time[i],Low[i]-25*Point);
        ObjectSet("   "+DoubleToStr(i,0),OBJPROP_ARROWCODE,116);
       }
                               //
       if(Open[i]==Close[i])
       {
        ObjectCreate(" "+DoubleToStr(i,0),OBJ_ARROW,0,Time[i],High[i]+30*Point);
        ObjectSet(" "+DoubleToStr(i,0),OBJPROP_ARROWCODE,174);
        ObjectSet(" "+DoubleToStr(i,0),OBJPROP_COLOR,Indigo);
       }
     i++;  
   }

           //
          //
          //
          //
          //
      
          if (alertsOn)
          {
            if (alertsOnCurrent)
                 int whichBar = 0;
            else     whichBar = 1;
            if (trend[whichBar] != trend[whichBar+1])
            if (trend[whichBar] == 1)
                  doAlert("Buy");
            else  doAlert("Sell");       
   }

return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," japan-indicator ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," japan-indicator " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " japan-indicator "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
      





































//+------------------------------------------------------------------+